<?
// $Id: update_db.inc.php,v 1.1.1.1 2008/11/06 10:53:10 antonio Exp $


$local_tables = $connh->MetaTables();
foreach ($remote_obj as $key=>$val) // scorre le tabelle del server
{
    $create_table = "";
    if (!in_array($key, $local_tables)) //se la tabella non esiste in locale
    {
        echo "<br />" . adm_update_tt_table_created . ": " . $key;
        flush();
        $create_table = "CREATE TABLE $key (";
    }
    $tables_array = $connh->MetaColumns($key); // prende i campi locali
    foreach ($remote_obj[$key] as $val) // scorre i campi del server
    {
        $tmpindex = strtoupper($val->name);
        $local = $tables_array[$tmpindex];
        if ($create_table != "")
        {
            //assemblo la query per creare la tabella $key
            $create_table .= "\n`".$val->name."` ".$val->type;

	    if (is_array($val->enums) && count($val->enums))
		$create_table .= "( " . implode(",", $val->enums) . ")";
	    else if ($val->max_length != '-1') $create_table .= "(".$val->max_length.")";


            if ($val->not_null == 1) $create_table .= " NOT NULL";
            else $create_table .= " NULL";
            if ($val->has_default && $val->type != 'timestamp' && $val->auto_increment != 1)
                $create_table .= " default '".$val->default_value."'";
            if ($val->auto_increment == 1) $create_table .= " AUTO_INCREMENT";
            if ($val->primary_key == 1) $create_table .= " PRIMARY KEY";
            $create_table .= " ".$val->binary;
            $create_table .= ",";
        }
        else
        {
            if (!strstr($key,"_content"))
            {
                if (empty($local) || $local->name == "") // se quel campo locale non esiste
                {
                    // crea quel campo con tutti gli attributi
                    $query = "ALTER TABLE $key ADD ";
                    $query .= "\n`".$val->name."` ".$val->type;
                    if ($debug) echo "<br>".$val->name.", tipo:".$val->type.", maxl:".$val->max_length;
		    if (is_array($val->enums) && count($val->enums))
			$query .= "( " . implode(",", $val->enums) . ")";
		    else if ($val->max_length != '-1') $query .= "(".$val->max_length.")";
                    if ($val->not_null == 1) $query .= " NOT NULL";
                    else $query .= " NULL";
                    if ($val->has_default && $val->auto_increment != 1) $query .= " DEFAULT '".$val->default_value."'";
                    if ($val->auto_increment == 1) $query .= " AUTO_INCREMENT";
                    if ($val->primary_key == 1) $query .= " PRIMARY KEY";
                    $query .= " ".$val->binary;

                    $rs = $connh->Execute($query);
                    if (!$rs) echo "<br><FONT color=red>" .
                    adm_update_err_db_table_alter . " " . "$key:<br>$query<br>" . $connh->ErrorMsg() . "<br>" .
                    adm_update_tt_contact . "</FONT>";
                    echo "<br>" . adm_update_tt_field . " "  . $val->name . " " . adm_update_tt_field_created;
                }
                else
                {
                    // controllo se bisogna alterare il campo $local->name
                    $query = "";
                    $start_query = "ALTER TABLE $key CHANGE `".$local->name."` `".$val->name."` ";
                    if ($local->name != $val->name or $local->type != $val->type or $local->max_length != $val->max_length or $local->not_null != $val->not_null or ($val->has_default && $local->default_value != $val->default_value) or $local->primary_key != $val->primary_key or $local->auto_increment != $val->auto_increment or $local->binary != $val->binary)
                    {
                        if ($debug) echo $local->name ."!=". $val->name ." or tipo: ". $local->type ."!=". $val->type ." or max_lenght: ". $local->max_length ."!=". $val->max_length ." or not_null: ". $local->not_null ."!=". $val->not_null ." or default_value: ". $local->default_value ."!=". $val->default_value ." or primary_key: ". $local->primary_key ."!=". $val->primary_key ." or auto_increment: ". $local->auto_increment ."!=". $val->auto_increment ." or binary: ". $local->binary ."!=". $val->binary;

                        $query .= $val->type;

		    	if (is_array($val->enums) && count($val->enums))
				$query .= "( " . implode(",", $val->enums) . ")";
		    	else if ($val->max_length != '-1') $query .= "(".$val->max_length.")";

                        if ($val->not_null == 1) $query .= " NOT NULL ";
                        else $query .= " NULL ";
                        if ($val->has_default && $val->auto_increment != 1) $query .= " DEFAULT '".$val->default_value."'";

                        //if ($val->primary_key == 1) $query .= "PRIMARY KEY ";
                        if ($val->auto_increment == 1) $query .= " AUTO_INCREMENT ";
                        $query .= " ".$val->binary;
                        echo "<br>" . adm_update_tt_field . " "  . $val->name . " " . adm_update_tt_field_updated;
                    }
                    if ($query != "")
                    {
                        $final_query = $start_query.$query;
                        if ($debug) echo "<br>$final_query";
                        $rs = $connh->Execute($final_query);
                        if (!$rs) echo "<br><FONT color=red>" .
                        adm_update_err_db_table_alter . " " . "$key:<br>$final_query<br>" . $connh->ErrorMsg() . "<br>" .
                        adm_update_tt_contact . "</FONT>";
                    }
                }
            }
        }
    }
    //crea la tabella (adesso perche' ho anche le info dei campi)
    if ($create_table != "")
    {
        $create_table = substr($create_table, 0, -1);
        $create_table .= ") type=myisam";
        if ($debug) echo "<br>".$create_table;
        $rs = $connh->Execute($create_table);
        if (!$rs) echo "<br><FONT color=red>" .
        adm_update_err_db_table_create . " " . "$key:<br>$create_table<br>" . $connh->ErrorMsg() . "<br>" .
        adm_update_tt_contact . "</FONT>";
    }
}

//spazza via tabelle e campi obsoleti
/*foreach ($local_tables as $key)
{
    if (!strstr($key,"content_"))
    {
        if ($debug) echo "<br>$key";
        foreach ($remote_obj as $rem_key=>$rem_val)
        {
            if ($key == $rem_key)
            {
                $found = true;
            }
        }
        if (!$found)
        {
            $query = "DROP TABLE $key";
            $rs = $connh->Execute($query);
            if (!$rs) echo "<br><FONT color=red>" .
            ADM_UPDATE_ERR_DB_TABLE_DELETE . " " . "$key:<br>" . $connh->ErrorMsg() . "<br>" .
            ADM_UPDATE_TT_contact . "</FONT>";
        }
        else
        {
            $tables_array = $connh->MetaColumns($key); // prende i campi locali
            foreach ($tables_array as $val) // scorre i campi locali
            {
                foreach ($remote_obj[$key] as $rem_val)
                {
                    if ($val->name == $rem_val->name)
                    {
                        $found_val = true;
                    }
                }
                if (!$found_val)
                {
                    $query = "ALTER TABLE $key DROP ".$val->name;
                    $rs = $connh->Execute($query);
                    if (!$rs) echo "<br><FONT color=red>" .
                    ADM_UPDATE_ERR_DB_FIELD_DEL1 . " " . $val->name . " " . ADM_UPDATE_ERR_DB_FIELD_DEL2 . " " . "$key:<br>" . $connh->ErrorMsg() . "<br>" .
                    ADM_UPDATE_TT_contact . "</FONT>";
                }
                unset($found_val);
            }
        }
    }
    unset($found);
}*/
?>
