<?php
// $Id: login.php,v 1.10 2010/07/09 14:03:11 riccardo Exp $

// mi connetto al db e carico le impostazioni
require_once "adm/lib/setup.php";

require_once "tools/lang/$lang/dialog.diz";
require_once "tools/lang/$lang/error.diz";

require PRISCILLA_LOCAL_PATH."tools/lang/".$lang."/adm_dialog.diz";


// carico la sessione PRISCILLA_SESSION
require_once "adm/lib/priscilla_session_init.inc.php";

//toglobaloff
$PRISCILLA_SESSION = $_SESSION['PRISCILLA_SESSION'];

$Excellent = true;

if (file_exists(PRISCILLA_LOCAL_PATH."modules/security/lib/security_class.php"))
{
    require_once PRISCILLA_LOCAL_PATH."modules/security/lib/security_class.php";
    $sec_obj = new security($connh);
    $sec_prefs = $sec_obj->getSecurityPrefs();
}

// eventuale redirezione https
if ($sec_prefs['security_https_login']) {

    $server_basedir = $_SERVER['SERVER_NAME'] . dirname($_SERVER['PHP_SELF']);
    if ($server_basedir{strlen($server_basedir) - 1} == '/')
        $server_basedir = substr($server_basedir, 0, -1);

    $https_login = "https://" . $server_basedir . "/login.php";

    // un test per capire se si e' gia' in https...
    if (trim($_SERVER['SSL_CIPHER']) == '')
        header("Location: " . $https_login);

}


function make_login_id ($login, $passwd) {

    srand ((float) microtime() * 10000000);
    $random_middle = rand();
    $mypreid = $login . $random_middle . $passwd;
    $login_id = md5($mypreid);

return $login_id;
}

$current_ip = $_SERVER['REMOTE_ADDR'];
$terminal = addslashes($_SERVER['HTTP_USER_AGENT']);
$hostname = gethostbyaddr($current_ip);

if ($_GET['logout'])
{
    $login_auth_id = rand();
    $last_login_log_id = $PRISCILLA_SESSION->getvalue('last_login_log_id');
    $PRISCILLA_SESSION->remove('login_auth_id');
    $PRISCILLA_SESSION->remove('usertable');

    if (session_is_registered('usertable'))
        session_unregister('usertable');

    unset($usertable);

    //session_unregister('login_auth_id');
    setcookie("login", "", 1, "", "", 0);
    setcookie("firma", "", 1, "", "", 0);
    $GLOBALS[extra] = "";
    $GLOBALS[daa] = "";

    if ($sec_prefs['security_login_log'])
        $connh->Execute("UPDATE `" . SECURITY_TABLE_GOOD_LOGIN . "` SET logoutdate = NOW() WHERE id = '" . $last_login_log_id . "' LIMIT 1");

    header("Location: index.php");
}
elseif ($_POST['username'] or $_POST['password'])
{

    $username = $_POST['username'];
    $password = $_POST['password'];

    $goodcode = true;
    if (trim($PRISCILLA_SESSION->getvalue('priscilla_img_code')) != '')
    {
        if ($_POST['randomcode'] != $PRISCILLA_SESSION->getvalue('priscilla_img_code'))
            $goodcode = false;
    }
    
    $password_clear = $password;
    
    $rowrs = $connh->Execute("SELECT * FROM user WHERE username = '".$username."'");
    if (defined('PRISCILLA_LDAP_MODE') && PRISCILLA_LDAP_MODE === true && ($rowrs->fields['ldap_user'] == 1 || !$rowrs->RecordCount())) {
        if (defined('PRISCILLA_LDAP_SERVER_PORT') && PRISCILLA_LDAP_SERVER_PORT != '')
            $ldap_port = PRISCILLA_LDAP_SERVER_PORT;
        else
            $ldap_port = 389;
        $lh = ldap_connect(PRISCILLA_LDAP_SERVER, $ldap_port);
        ldap_set_option($lh, LDAP_OPT_PROTOCOL_VERSION, PRISCILLA_LDAP_PROTOCOL_VERSION);
        if (defined('PRISCILLA_LDAP_AUTH_USERNAME_QUERY') && PRISCILLA_LDAP_AUTH_USERNAME_QUERY != '')
            $ldap_username = sprintf(PRISCILLA_LDAP_AUTH_USERNAME_QUERY, $username);
        else
            $ldap_username = $username;

        if (@ldap_bind($lh, $ldap_username.','.PRISCILLA_LDAP_BASE_DN, $password) === false)
            $found = 0;
        else {
            $found = 1;

            if (defined('PRISCILLA_LDAP_AUTH_GROUP') && PRISCILLA_LDAP_AUTH_GROUP != '') {
                if (!($gs = ldap_search($lh, PRISCILLA_LDAP_AUTH_GROUP.','.PRISCILLA_LDAP_BASE_DN, 'memberUid='.$username)))
                    $found = 0;
                $ldap_groupinfo = ldap_get_entries($lh, $gs);
                if (!$ldap_groupinfo['count'])
                    $found = 0;
    
                if (!in_array($username, $ldap_groupinfo[0]['memberuid']))
                    $found = 0;
            }

            if ($found) {
                // if ldap user is not yet linked in priscilla
                if (!$rowrs->RecordCount()) {
                    $connh->Execute("INSERT INTO user(username, ldap_user) VALUES('".$username."', 1)");
        
                    // e poi lo riprendo in modo da avere il recordset riempito dei default pronto per dopo
                    $rowrs = $connh->Execute("SELECT * FROM user WHERE username = '".$username."'");
                }
        
                $rowrs->fields['password'] = $password;
            }
        }
    }
    else {
        // se le password sono crittate
        $rscrypt = $connh->Execute("SELECT SHA1('" . $password . "') as cryptedpass") or die ("Fatal Error: SHA1 function not available.\n");
        $password = $rscrypt->fields('cryptedpass');
    
        $dbquery = "SELECT * FROM user WHERE username='$username' and password='$password'";
        $rowrs = $connh->Execute($dbquery);
        $found = $rowrs->RecordCount();
    }

    if ($found > 0 && $goodcode)
    {
        $row = $rowrs->fields;

        if ($row['password'] == $password) {
           
            $PRISCILLA_SESSION->add('n_failed_login', 0);
            $Excellent = true;
            if ($row[sospeso] != 'si')
            {

                $login = $row[username];
                $cexpire = 0; //time()+86400;
                $cpath = "";
                $cookiedom = "";

                // generazione login_auth_id
                $crc = make_login_id($login, $password);

                /*if (!session_register('login_auth_id'))
                die("Fatal Error: Could not register session variable");*/

                $login_auth_id = md5($login.$crc);
                $PRISCILLA_SESSION->add('login_auth_id', $login_auth_id);
                $row['password'] = 'MASKED';
                $PRISCILLA_SESSION->add('usertable', $row);

                $lingua = (trim($row['lingua']) ? $row['lingua'] : $lang);
                $sk = (trim($row['skin']) ? $row['skin'] : $skin);
                $PRISCILLA_SESSION->add('lingua', $lingua);
                $PRISCILLA_SESSION->add('sk', $sk);

                // al solito, si mandano i cookie (firma e' il nostro login_auth_id)
                setcookie("login", $login, $cexpire, $cpath, $cookiedom, 0);
                setcookie("firma", $crc,  $cexpire, $cpath, $cookiedom, 0);

                // logging login buoni
                if ($sec_prefs['security_login_log'] && $Excellent == true && $sospeso == false) {
            
                    $dbquery = "INSERT INTO " . SECURITY_TABLE_GOOD_LOGIN .
                        " (uid, terminal, host, logdate) VALUES ('$row[id]', '$terminal', '$hostname', NOW())";
                    $rs = $connh->Execute($dbquery) or die("Could not register login info.");
                    $PRISCILLA_SESSION->add('last_login_log_id', $connh->Insert_ID());
                }

                // notifica via email
                if ($sec_prefs['security_login_notify_user'] || $sec_prefs['security_login_notify']) {
            
                    if (!function_exists("GetMXRR")) {
                        $_NAMESERVERS = array();
                        require("packages/smtp/getmxrr.php");
                    }
                    require ("packages/smtp/smtp.php");
            
                    $smtp = new smtp_class;
                    $smtp->host_name = $smtpserver; /* relay SMTP server address */
                    $smtp->localhost = "localhost";         /* this computer address */
                    $smtp->direct_delivery = 0;     /* Set to 1 to deliver directly to the recepient SMTP server */
                    $smtp->debug = 0;               /* Set to 1 to output the communication with the SMTP server */
                    $smtp->user = $smtpuser;        /* Set to the user name if the server requires authetication */
                    $smtp->realm = $smtprealm;      /* Set to the authetication realm, usually the authentication user e-mail domain */
                    $smtp->password = $smtppassw;   /* Set to the authetication password */
            
            
                    $mail_from = "noreplay@" . $_SERVER['SERVER_NAME'];
                    $subject = "Priscilla ($priscilla_server_path) user [$username] login";
                    $mailer = "Priscilla Login Notifier";
                    $mail_date = strftime("%a, %d %b %Y %H:%M:%S %Z");
            
                    $message =
                        "\n\nPriscilla " . $priscilla_server_path . "\n\n" .
                        "user: $username\n" .
                        "host: $hostname\n" .
                        "terminal: $terminal\n" .
                        "time: $mail_date\n\n";
            
                    // notifica al redattore
                    if ($sec_prefs['security_login_notify_user'] && trim($row['email']) != '') {
            
                        $tomail = $row['email'];
            
                        $headers = array(
                            "From: " . $mail_from,
                            "To: " . $tomail,
                            "Subject: $subject",
                            "X-Mailer: " . $mailer,
                            "Date: " . $mail_date
                        );
            
                        $smtp->SendMessage ($mail_from, array($tomail), $headers, $message);
            
                    }
            
                    // notifica generale    
                    if ($sec_prefs['security_login_notify'] && trim($sec_prefs['security_login_notify_email']) != '') {
            
                        $tomail = $sec_prefs['security_login_notify_email'];
            
                        $headers = array (
                            "From: " . $mail_from,
                            "To: " . $tomail,
                            "Subject: $subject",
                            "X-Mailer: " . $mailer,
                            "Date: " . $mail_date
                        );
            
                        $smtp->SendMessage ($mail_from, array($tomail), $headers, $message);
                    }
                }

                // controllo se la password e' scaduta (il superuser e' esentato)
                if ($sec_prefs['security_passwd_expire'] && $row['username'] != 'superuser') {

                    if ($row['lastpasswordchange'] != '0000-00-00 00:00:00')
                    {
                        $dbquery = "SELECT DATEDIFF(NOW(), '" . $row['lastpasswordchange'] . "') as ndays";
                        $rs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br>" . $connh->ErrorMsg());
                        //$ndays = round(((time() -  $rs->fields('lastpasswordchange_time')) / 86400));
                        $ndays = $rs->fields['ndays'];

                        if (abs($ndays) > $sec_prefs['security_passwd_expire_days']) {
    
                            $change_password_message = sprintf(dialog_gen_password_expired, $ndays);
                            $PRISCILLA_SESSION->add('change_password_message', $change_password_message);
                            $PRISCILLA_SESSION->add('have_to_change_password', true);
    
                            header("Location: tools.php?action=change_expired_password");
                            die();
                        }
                    }
                    else
                    {
                        $query = "UPDATE user SET lastpasswordchange = NOW() WHERE id='".$row['id']."'";
                        $rs = $connh->Execute($query) or die("ERROR: $query<br>" . $connh->ErrorMsg());
                    }
                }

                // forza cambio password se questa non e' abbstanza sicura
                if ($sec_prefs['security_force_passwd_change'] && $row['username'] != 'superuser') {

                    require_once "lib/util.inc.php";

                    if (!isValidPassword($password_clear)) {
                        $change_password_message = dialog_gen_password_insecure;
                        $PRISCILLA_SESSION->add('change_password_message', $change_password_message);
                        $PRISCILLA_SESSION->add('have_to_change_password', true);
                        header("Location: tools.php?action=change_expired_password");
                        die();
                    }
                }

                if (!isset($row[at_login]) or $row[at_login] == '')
                {
                    header("Location: modules/paper/lib/actions.php?action=show_tree&id_node=1");
                    die();
                }
                else
                {
                    header("Location: $row[at_login]");
                    die();
                }
            }
            else $sospeso = true;
        }
        else $Excellent = false;
    }
    else
    {
        $Excellent = false;
    }
    
    if (!$Excellent)
    {
        // attesa per login falliti
        if ($PRISCILLA_SESSION->exists('n_failed_login')) {
            $n_failed_login = $PRISCILLA_SESSION->getvalue('n_failed_login');
            $secs_to_sleep = pow(2, $n_failed_login);
            if (is_integer($secs_to_sleep))
                sleep($secs_to_sleep);
        }
    }
    
    // traccia per ritardo login su login falliti
    if ($Excellent == false) {
        if ($PRISCILLA_SESSION->exists('n_failed_login'))
            $n_failed_login = $PRISCILLA_SESSION->getvalue('n_failed_login');
        else
            $n_failed_login = 0;

        $n_failed_login++;

        $PRISCILLA_SESSION->add('n_failed_login', $n_failed_login); 
    }

    // logging failed login
    if ($sec_prefs['security_login_failed_log'] && ($Excellent == false || $sospeso == true)) {    

        $dbquery = "INSERT INTO " . SECURITY_TABLE_FAILED_LOGIN .
            " (username, terminal, host, logdate) VALUES ('$username', '$terminal', '$hostname', NOW())";
        $rs = $connh->Execute($dbquery) or die("Could not register login info.");
    }
}

include PRISCILLA_LOCAL_PATH."adm/include/html_head.inc.php";
include("adm/include/title.txt");
print "<link rel=\"stylesheet\" type=\"text/css\" href=\"adm/skin/$skin/default.css\">";
print "<!--[if lte IE 7]>
			<link rel=\"stylesheet\" type=\"text/css\" href=\"adm/skin/ie6.css\" />
		<![endif]-->";
print "</head>";
//include("adm/skin/$skin/body.inc");

?>
<body class="login">
<div id="pp-login">
    <div id="pp-login-wrap">
    <h1>Priscilla CMS - login</h1>
    <form method="post" action="" id="pp-loginform">
    <fieldset>
    <div class="row">
        <label for="username"><? print dialog_gen_uid; ?></label>
        <input class="insert_voice" type="text" id="username" name="username" tabindex="1" size="16" />
    </div>    
    <div class="row">
        <label for="username"><? print dialog_gen_pwd; ?></label>
        <input class="insert_voice" type="password" id="password" name="password" tabindex="2" size="16" />
    </div> 
    <div class="row">
        <input class="button_in awesome" type="submit" value="<? print dialog_but_acces; ?>" />
    </div>    
   <p class="login_form_message">
    <?
    if ($sospeso == true) print "<span class=\"insert_message\"><strong>" . err_sospeso . "</strong></span>";
    elseif ($Excellent == false) print "<span class=\"insert_message\"><strong>" . err_password . "</strong></span>";
    else print dialog_desc_login; ?><br />
    </p>
<?
if ($sec_prefs['security_login_captcha'] && file_exists($priscilla_local_path."modules/security/lib/login_captcha.php"))
{
    require_once $priscilla_local_path."modules/security/lib/login_captcha.php";
    if (my_extension_ok('gd'))
    {
        $random_code = randuid(6);
        $PRISCILLA_SESSION->add('priscilla_img_code', $random_code);
?>
    <div class="row">
        <label for="randomcode">Copia il codice che leggi nell'immagine</label>
        <img src="<? echo $priscilla_server_path; ?>modules/security/lib/mkimgstamp.php" alt="captcha code"/>
        <input tabindex="3" type="text" maxlength="6" size="6" id="randomcode" name="randomcode" class="inputtext" />
    </div>
<?
    }
}
else if ($PRISCILLA_SESSION->exists('priscilla_img_code'))
    $PRISCILLA_SESSION->remove('priscilla_img_code');
?>
    </fieldset>
    </form>
    </div> <!-- end pp-login-wrap -->
</div> <!-- end pp-login-->
<div class="credits_full centra"><? print adm_about_pj; ?>
   <br /><? print adm_about_online; ?></div>

</body></html>
