<?php

$debug = 0;

require "../../../adm/lib/setup.php";

// carico la sessione PRISCILLA_SESSION
require_once "../../../adm/lib/priscilla_session_init.inc.php";


// riprendo l'id generato al login, altrimenti vuoto
if ($PRISCILLA_SESSION->exists('login_auth_id'))
    $login_auth_id = $PRISCILLA_SESSION->getvalue('login_auth_id');
else
    $login_auth_id = '';


$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

// alcune variabile tabellari
$TABLE_CATALOGO             = 'catalogo';
$TABLE_CATALOGO_CONTENT     = 'catalogo_content';
$DESC_LENGTH                 = 50;

if ($PRISCILLA_SESSION->exists('priscilla_catalog_search')) {
    $PRISCILLA_SESSION->remove('priscilla_catalog_search');
    unset($priscilla_catalog_search);
}

$priscilla_catalog_search = array();

require "catalog.lib.php";

function out_debug_msg ($msg) {

    echo
        "<span style=\"color:red\"><strong>#debug:</strong></span>" .
        "<br />" . htmlentities($msg) . "<br />\n" .
        "<span style=\"color:red\"><strong>#gubed:</strong></span><br /><br />";
}

function get_catalog_node_id ($gid, $modepub = '') {
global $connh;

	return $_POST["catalog_page_id"];


/////////////////////////////// stop here

    $tag_to_search = "{catalogo id=&quot;$gid&quot;$modepub}";

    if ($modepub != "")
        $modepub = " public=" . "\\\\\\\\\"" . "yes" . "\\\\\\\\\"";

    $tag_to_search_quote = "{catalogo id=" . "\\\\\\\\\"" . $gid . "\\\\\\\\\"" . "$modepub}";


    // elenco dei content usati    
    // alla stessa maniera del motore di ricerca (si ruma solo in documenti pubblici)
    // possibili meglioramente nella gestione se si e' loggati o meno, superuser,
    // tipo di pubblicazine delle pagine, ecc.
    // occorrono funzioni di verifica di login senza sbattere fuori
    // o meglio si cerca su tutto, link risultato visibile e si entra solo con permessi per quel documento
    $dbquery = "SELECT DISTINCT contenuto FROM node WHERE pubblicazione = 'pubblica'";
    $rsearch = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());    
    
    while (!$rsearch->EOF) {
        $where_clause = '';
        // i campi text di questo content
        $dbsubquery = "SELECT * FROM " . $rsearch->fields('contenuto');
        $rowrs = $connh->Execute($dbsubquery) or die("ERROR: $dbsubquery<br />".$connh->ErrorMsg());    
        for ($i = 0; $i < $rowrs->FieldCount(); $i++) {
            $field = $rowrs->FetchField($i);
            if (strtoupper($rowrs->MetaType($field->type)) == "X") {
                if ($where_clause != '')
                    $where_clause .= ' OR ';
                $where_clause .= "(" . $field->name . " LIKE '%" . $tag_to_search . "%' OR $field->name LIKE '%" . $tag_to_search_quote . "%') ";
            }
        } // for
               

	if ($where_clause != "") {

	        $dbtagquery =
        	    "SELECT id FROM " . $rsearch->fields('contenuto') . " WHERE " . $where_clause;

	//        echo $dbtagquery . "<br />";


        	$tagres = $connh->Execute($dbtagquery) or die("ERROR: $dbtagquery<br />".$connh->ErrorMsg());    
        
	        if ($tagres->RecordCount())
        	    return $tagres->fields('id');        
	}
                
        $rsearch->MoveNext();
    } // while
   
return -1;
} // get_catalog_node_id


// qui dobbiamo capire se si viene dal form
if (isset($bCatalogSearchGo)) {
    
    // in altri contesti questa avrebbe fatto risparmiare un po' di conti
    if ($search_id_catalogo && !isset($catalogo_node[$search_id_catalogo]))
        $catalogo_node[$search_id_catalogo] = get_catalog_node_id($search_id_catalogo);

    // alla ricerca di catalogo pubblico
    if ($catalogo_node[$search_id_catalogo] == -1)
    $catalogo_node[$search_id_catalogo] = get_catalog_node_id($search_id_catalogo, " public=&quot;yes&quot;");


    // che anno e'? che giorno e' ...
    $att = date("Ymd");
    $DZERO = '00000000';

    $catalogo_name = $search_id_catalogo;

    if (isset($search_id_catalogo) && is_numeric($search_id_catalogo) && $search_id_catalogo != 0) {
        // l'utente del catalogo in questo caso ci interessa...
        $dbquery = "SELECT nome, id_user FROM $TABLE_CATALOGO WHERE id = '$search_id_catalogo'";
        $rs = $connh->Execute($dbquery) or die("<br />ERROR: $dbquery<br />" . $connh->ErrorMsg());
        $grow = $rs->fields;
        
        $catalogo_name = $grow[nome];
        
        if (($_COOKIE['login'] == $grow[id_user] || $_COOKIE['login'] == 'superuser')
            && ($PRISCILLA_SESSION->exists('login_auth_id') && trim($login_auth_id) != '' && $login_auth_id == md5($_COOKIE['login'].$firma)))
            $content_select_part = 'content_visible >= 0';
        else            
            $content_select_part =
                "content_visible = '1' AND ((da=$DZERO AND a=$DZERO) OR (da<=$att AND a=$DZERO) OR (da=$DZERO AND $att<a) OR (da<=$att AND $att<a))";
            
        $CATALOG_SELECT = "WHERE ($content_select_part) AND (gid = '$search_id_catalogo')";        
     } else {
        if ($_COOKIE['login'] == 'superuser' && ($PRISCILLA_SESSION->exists('login_auth_id') && trim($login_auth_id) != '' && $login_auth_id == md5($_COOKIE['login'].$firma)))
            $content_select_part = 'content_visible >= 0';
        else            
            $content_select_part =
                "content_visible = '1' AND ((da=$DZERO AND a=$DZERO) OR (da<=$att AND a=$DZERO) OR (da=$DZERO AND $att<a) OR (da<=$att AND $att<a))";
         
        $CATALOG_SELECT = "WHERE ($content_select_part)";
    }

    // andiamo a vedere l'elenco dei campi in cui si ricerca
    $elenco_campi_ricerca = '';
    $elenco_valori_ricerca = '';
    
    if (isset($cs_name) && is_array($cs_name)) {
        while (list($k, $v) = each($cs_name)) {
        
            if (strlen($v) > 0 && trim($v) != '') {            
                // che tipo di aggancio
                $curr_k_aggancio = $cs_and_or[$k];
                
                if ($elenco_campi_ricerca != '')
                    $elenco_campi_ricerca .= ', ';
                else $curr_k_aggancio = 'AND';
                
                $elenco_campi_ricerca .= $k;
                
                // che tipo di ricerca
                if ($cs_search_mode[$k] == '=')
                    $curr_k_val = "$k = '$v'";
                else
                    $curr_k_val = "$k LIKE '%$v%'";
                
                $elenco_valori_ricerca .= ' ' . $curr_k_aggancio . ' (' . $curr_k_val . ')';  
            } // if (strlen 
            
        } // while
    } // isset($cs_name

    if ($elenco_campi_ricerca != '') {

        $elenco_campi_ricerca = 'id, gid, ' . $elenco_campi_ricerca;
        $BEGIN_QUERY = "SELECT $elenco_campi_ricerca FROM $TABLE_CATALOGO_CONTENT";

        if ($cs_orderby != "" && $cs_order_verso != "")
            $ORDER_SETTINGS = " ORDER BY gid, " . $cs_orderby . " " . $cs_order_verso;
        else
            $ORDER_SETTINGS = " ORDER BY gid";

        $dbquery = $BEGIN_QUERY . ' ' . $CATALOG_SELECT . $elenco_valori_ricerca . $ORDER_SETTINGS;

        if ($debug)
            out_debug_msg("elenco campi ricerca: $elenco_campi_ricerca<br />QUERY DI RICERCA: ***$dbquery***");

        // si cerca per davvero
        $rsearch = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
    
        if ($rsearch->RecordCount() > 0) {
            
            // ci sono risultati, una tantum se e' il caso (non stiamo cercando su tutti i cataloghi)
            // facciamoci un indice di catalogo            
            if ($debug)
                out_debug_msg("catalog id = $search_id_catalogo --- catalog page = $catalogo_node[$search_id_catalogo]");
            
            if ($search_id_catalogo && $catalogo_node[$search_id_catalogo] != -1) {
                $cs_catalog_index = make_index_for_catalog_pages($search_id_catalogo);
                $cs_catalog_index_num = count($cs_catalog_index);
/*                
                echo "<br />\n";
                print_r($cs_catalog_index);
                echo "<br />\n";
*/                
            }

            while (!$rsearch->EOF) {
                $csrow = $rsearch->fields;
                if (isset($nomi_catalogo[$csrow[gid]]))
                    $catalog_part = "'" . $nomi_catalogo[$csrow[gid]] . "'";
                else
                    $catalog_part = $csrow[gid];
                $outtextitem = 'Scheda' . ' ' . $csrow[id] . ', ' . 'Catalogo' . ' ' . $catalog_part;
                $urlstuff = '';
                if ($search_id_catalogo) {
                    if (isset($catalogo_node[$search_id_catalogo]) && is_numeric($catalogo_node[$search_id_catalogo])) {
                        $urlstuff = 'id=' . $catalogo_node[$search_id_catalogo];
                        $id_cat = $catalogo_node[$search_id_catalogo];

                        // e se abbiamo anche la sottopagina
                        if ($cs_catalog_index_num) {
                            if (isset($cs_catalog_index[$csrow[id]]) && is_numeric($cs_catalog_index[$csrow[id]])) {
                                $urlstuff .= '&cat_vis_start=' . $cs_catalog_index[$csrow[id]];
                                $nsubpage = $cs_catalog_index[$csrow[id]];
                            } else $nsubpage = 0;    
                        } // if ($cs_catalog_index_num
                        else $nsubpage = 0;                                                
                    } // if (isset...
                    else $id_cat = 0;                    
                } // if ($search_id_catalogo
                
                // se abbiamo uno straccio di url
                if ($urlstuff != '') {

                    // almeno un campo testo c'e', pero' prendiamone uno che sia stato utilizzato nella ricerca
                    // e che sia non vuoto
                        
                    reset($cs_name);
                    $currdescr = '';
                    while (list($k, $v) = each($cs_name))
                        if (strlen($csrow[$k]) > 0) {
                            $currdescr = $csrow[$k];
                            break;
                    }

                    if (!$DESC_LENGTH)
                        ;
                    else {
                        if (strlen($currdescr) > $DESC_LENGTH) {
                            $currdescr = substr($currdescr, 0, $DESC_LENGTH);
                            // rendiamo migliore la stampa del testo trovato
                            $lung = strlen($currdescr);
                            for ($s = $lung - 1; $s > -1; $s--)
                                if ($currdescr{$s} == ' ') {
                                    $currdescr = substr($currdescr, 0, $s) . '...';                                    
                                    break;
                                } // if ($currdesc                                                                   
                        } // if (strlen
                    } //else
                    $currt = array('id_cat' => $id_cat, 'nitem' => $csrow[id],
                        'startpage' => $nsubpage, 'descr' => $currdescr, 'name_cat' => $catalogo_name);

                    $priscilla_catalog_search[] = $currt;
                }                
                // se non abbiamo uno straccio di riferimento non stampiamo niente                
                $rsearch->MoveNext();
            } // while
        } else {
            // qui non abbiamo trovato niente
        }
    } // if $elenco_campi_ricerca
    else {
        // qui non abbiamo neanche cercato, volendo si potrebbe dare questo messaggio
    }

    // registriamo i risultati
    $PRISCILLA_SESSION->add('priscilla_catalog_search', $priscilla_catalog_search);
}
@header("Location: ../../../index.php?id=$idp");
header("Cache-Control: no-cache");
header("Expires: -1");
?>
